package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type UpdateFirewallGroupLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewUpdateFirewallGroupLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdateFirewallGroupLogic {
	return &UpdateFirewallGroupLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UpdateFirewallGroupLogic) UpdateFirewallGroup(req *types.UpdateFirewallGroupReq) (resp *types.UpdateFirewallGroupResp, err error) {
	// todo: add your logic here and delete this line
	UpdateFirewallGroupReq := &openstack.UpdateFirewallGroupReq{}
	err = copier.CopyWithOption(UpdateFirewallGroupReq, req, copier.Option{Converters: utils.Converters})
	UpdateFirewallGroupResp, err := l.svcCtx.OpenstackRpc.UpdateFirewallGroup(l.ctx, UpdateFirewallGroupReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&UpdateFirewallGroupResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &UpdateFirewallGroupResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
